#include "mbed.h"
#include "SDFileSystem.h"
#include "EthernetInterface.h"
#include "FTPClient.h"
#include <string.h>
#include <stdio.h>
#define FTP_SERVER_PORT     21
 static char buf[256];
 DigitalIn P1(D2);
static char ID[]={"FTP"};                   //Set FTPServer Login ID
static char PASSWORD[]={"user"};  //user           //Set FTPServer Login Password
FTPClient FTP(PB_3, PB_2, PB_1, PB_0, "sd"); // WIZwiki-W7500 
Serial pc(USBTX, USBRX);
int main() {
     pc.baud(9600);
    
    pc.printf("------------------------------FTP Client Example-------------------------------------------!\r\n"); 
      
  
    char ftpServer_control_ip_addr[] = "192.168.0.100"; // FTP Server location
    char* userid = "FTP"; //FTP Server User ID
    char* pass = "user"; //FTP Server Password
    EthernetInterface eth;
    uint8_t mac_addr[6] = {0x00, 0x08, 0xdc, 0x12, 0x34, 0x45};
    char IP_Addr[] = "192.168.0.101";
    char IP_Subnet[] = "255.255.255.0";
    char IP_Gateway[] = "192.168.0.1";
    eth.init(mac_addr, IP_Addr, IP_Subnet, IP_Gateway); //Use Static
    eth.connect();
    pc.printf("\nThe IP address of the client is %s\r\n",eth.getIPAddress());
    
    while(1) {     
                    pc.printf("\nConnecting...FTPServer\r\nIP:%s, PORT:%d\r\n", ftpServer_control_ip_addr, FTP_SERVER_PORT);
                   
                   /*TO connect to online Server uncomment the below line*/ 
                    //FTP.open("demo.wftpserver.com");
                    
                    bool n  = FTP.open("192.168.0.100", 21,"FTP","user");
                   
                    printf("\nThe Files and folders available in the server are :\r\n");
                    FTP.ls();
                    printf("\r\n");
                    wait(10);
                    printf("The Files in upload folder are :\r\n");
                    FTP.cd("/upload");
                    FTP.ls();
                    wait(10);
                    printf("The Files in download folder are :\r\n");
                    FTP.cd("/download");
                    FTP.ls();
                    printf("\r\n");
                    wait(10);
                    FTP.cd("/image");
                    FTP.ls();
                    /*
                    To get file from server to client use command "getfile" and to upload file from client to server use command "putfile"
                    //Example of uploading a image file from server to client 
                    FTP.getfile("/ftp/vlcsnap-3279000.jpg","vlcsnap-3279000.jpg");
                    printf("succesfull getting image from server");
                    */
                    //Uploading a text file from server named as k.txt
                    FTP.getfile("/ftp/k.txt","k.txt");
                    FTP.dir();
                    wait(10);
                    FTP.cd("/download");
                    //creating directory/folder 
                    FTP.mkdir("test1");
                     FTP.cd("test1");
                     //Uploading image file from client that is "sd" card in this case to server
                     //name of image is vlcsnap-3279000.jpg in sd card but will be stored as k.jpg in server
                    FTP.putfile("/sd/vlcsnap-3279000.jpg","k.jpg");
                    FTP.dir();
                    wait(10);
                    //To disconnect the FTP connection
                    FTP.quit();
            

}
}